#
# Program that validates a seed code sequence and generates a bitstream 
# 
# python3 stgc_process.py <seedcodefile> <l>
#
#  
#    seedcodefile: file with seedcode sequence, words separated by , 
#
#    seed code sequences can be generated by lyndon_words.py
#
# Check for validation errors
# if errors/violations change l (no common dividers with bitlength)
# 
#
# If none bitstring.dat contains 2 lines:
#
#   1st line: bitlentgh
#   2nd line: Bitstring
#
#
#
import csv
import re
import sys

def ggt (x, y):
    'Berechnet den groessten gemeinsamen Teiler zweier Zahlen'
    if x <= 0:
        return y
    else:
        return ggt (y % x, x)

# find v in array a and return index
def indexOf(a,v):
  i=0
  for x in a:
    if v==x:
       return i
    i=i+1 
  return None
 
def transition(word,word2):
   for i in range(0,len(word)):
      c1=word[i]
      c2=word2[i]
      if word[i] != word2[i]:
         return i
   return None
   
  
def histogram(s):
  h={}
  for x in s:
    if x in h.keys():
       h[x] = h[x]+1
    else:
       h[x]=1
  return h

  
def transitionSequence(words):
  ts=[]
  for i in range(0,len(words)):
    ts.append( transition( words[i],words[(i+1) % len(words)]))
  return ts 

def flip(word,t):
 #   print("w",word[0:t],word[t:][1:])  
    if word[t]=="0":
       word=word[0:t] + "1" + word[t:][1:]
    else:
       word=word[0:t] + "0" + word[t:][1:]
    return word
  
  
word="11010111"
for i in range(0,len(word)):
  print( i, flip(word,i))
  
  
#o=10/0 
def applyTransitionSequence(word,tseq):
  words=[]
  for t in tseq:
    words.append(word)
    word=flip(word,t)
   # if word in words:
   #    print("applyTransitionSequence duplicate:",word,len(words))
  return words
  

def normalizeSequence(tseq):
  k = 0
  t = {}
  ntseq = []  
  for i in range(0,len(tseq)):
     if tseq[i] in t.keys():
        ntseq.append( t[tseq[i]] )
     else:
        ntseq.append(k)
        t[tseq[i]]=k
        k=k+1
  return ntseq
  
# cyclic left shift of word
def e(word):
   sword=''
   for i in range(1,len(word)):
     sword=sword + word[i]
   sword = sword + word[0]
   return sword 

# cyclic left shift by l times of word   
def el(word,l):
  sword = word
  for i in range(0,l):
     sword = e(sword)   
  return sword
  
# number of differences of two words
def differences(w1,w2):
  d=0
  for i in range(0,len(w1)):
    if w2[i] != w1[i] :
       d = d+1
  return d
    
state = 0
n = 0
col=-1
words = []
heads=0

if len(sys.argv)>1:
  filename= sys.argv[1]
  with open(filename, newline='') as csvfile:
   spamreader = csv.reader(csvfile, delimiter=',', quotechar='|')
   for row in spamreader:
      print("row",row)
      for word in row:
         word=word.replace(" ","")
         word=word.replace("'","")
         if heads==0:
             heads=len(word)
         words.append(word)
         print(word) 

bitstring=''

print(words)

#  print(len(codetab))
#  for r in range(0,len(codetab[0])):  
#   for c in range(0,len(codetab)):  
#    if r < len(codetab[c]): 
#       if c+1 >=  len(codetab):
#          c2 = 0
#          r2 = r+1
#       else:
#          c2 = c+1
#          r2 = r
#      # print("{} {}  {} {}".format(c,r,c2,r2))
#       if r2 > len(codetab[c2])-1 : 
#          c2 = 0
#          r2 = 0 
#      # print("{} {}  {} {}".format(c,r,c2,r2))
#      # print( "{} - {} {}  {} {} {}".format(differences(codetab[c][r],  codetab[c2][r2]),c,r,c2,r2,codetab[c][r]))
#       words.append(codetab[c][r])
#words=  ['000001', '000101', '100101', '110101', '110001', '110011', '010011', '000011']
#words=['000001','000101','000111','010111','011111','001111','001011','000011']

#words = [ '000001','000011','000111','001111','011111','011101','001101','000101'] # not ok aber ok  it l=2
#heads=6

print(transitionSequence(words))
#tseq=normalizeSequence(transitionSequence(words)) # does not produce necklaces!
#words = applyTransitionSequence(words[0],tseq)
#print(len(words),words)

h = histogram( transitionSequence(words) )
su=0
for k in h.keys():
  su = su + h[k]
  print("{} : {}".format(k,h[k]))
print("Sum:{} Len:{}".format(su,len(words)))

#o=9/0


# must be adjusted accordingly
if len(sys.argv) > 2:
  l=int(sys.argv[2])
else:
  l=1

# Generate necklace ordering STGC from seed code sequence
#
gwords= []
r = len(words)
for n in range (0,heads):
   for i in range (0,r):
     word = words[i]
     word2=el(word,l*n)
     gwords.append(word2)

awords = []
for i in range (0,r):
   u=""
   for n in range (0,heads):
     u=u+gwords[n*r+i  ][0]
   awords.append(u)
   
print(len(awords))
words=awords

# Method C: Cn -> Cn+1, 
# Erzeugt zwar einen Gray-Code, leier nicht STGC
# Heads 12
words2 = []
bit = False
for word in words:
   if bit:
      words2.append(word + "1")
      words2.append(word + "0")
      bit=False
   else:
      words2.append(word + "0")
      words2.append(word + "1")
      bit=True
#words=words2
#heads = heads+1
#o=9/0
print("Number of words: {}".format(len(words))) 





#heads=7
#words = [   '0000001','0000101','0001101','0001001','1001001','1011001',
#            '1111001','1111101','0111101','0110101','0110111','0100111',
#            '0100101','1100101','1000101','1000111','0000111','0000011'
#        ] 
        
#heads=9
#words = [   '000000001','000000101','100000101','110000101','010000101','010000111','010000011','011000011','001000011','001000001','001100001','000100001','000110001','001110001',
#            '001010001','011010001','010010001','010110001','011110001','011111001','001111001','000111001','000111011','000110011','000110111','000110101', '000111101','100111101',
#            '100101101','100100101','110100101','010100101','011100101','001100101','001100111','001101111','001101011','001101001','101101001','111101001','110101001','110111001',
#            '110111011','110101011','010101011','011101011','111101011','101101011','101101111','111101111','111001111','110001111','100001111','000001111','000000111','000000011'
#        ] 
        
#heads=10
#words = [   '0000000001','0000000101','1000000101','1100000101','0100000101','0100000111','0100000011','0110000011',
#            '0010000011','0010000001','0011000001','0001000001','0001100001','0011100001','0010100001','0110100001',
#            '0100100001','0101100001','0111100001','0111110001','0011110001', '0001110001','0000110001','0000110011',
#            
#            '0000110111','0000110101','0000111101','0000111001','0000111011','1000111011','1000101011','1000101001',
#            '1000101101','1000100101','1000110101','1000110111','1000110011','1100110011','1100110001','1110110001',
#            '1110010001','0110010001','0100010001','0100010011','0100010111','0100010101','0100011101','0100011001',#
#
#            '0100011011','0100011111','0110011111','0010011111','0010010111','0010010011','0010010001','1010010001',
#            '1010010011','1010010111','1010010101','0010010101','0110010101','1110010101','1110010111','0110010111',
#            '0110010011','0110011011','0110011001','0110111001','0100111001','0100111011','0100110011','0101110011',#
#
#            '0101010011','0111010011','0111110011','0111111011','0111101011','0011101011','0011101111','1011101111',
#            '1011100111','1010100111','1010100101','1010101101','1010101111','1010101011','1011101011','1111101011',
#            '1111101111','1111001111','1110001111','1100001111','1000001111','0000001111','0000000111','0000000011'
#]



# check for duplicates
print("Duplicate check")
for i in range(0,len(words)):
  for j in range(0,len(words)):
     if i != j and words[i] == words[j]:
        print("Duplicate {}".format(words[i]))
print("Done")

# check for 1-bit differences
print("Gray Code check")
for i in range(0,len(words)):
   word1 = words[i]
   word2 = words[(i+1) % len(words)]
   d=differences(word1,word2)
   if d>1:
      print("{}: {} {} vs. {}".format(i,d,word1,word2))
print("Done")

# neclace check
print("Necklace check")
for i in range(0,len(words)):
   word = words[i]
   word0 = word
   for l in range(0,heads-1):
      word = e(word)
      if word == word0:
         print("E({}) {} = {}".format(l+1,word,word0))
print("Done")
#o=9/0

offset=0
thel=0
take=0
hit=0
print("Cyclic Code check")
# find offset so code will be cyclic
for l in range(1,heads): # range(1,heads):
  # l und heads teilerfremnd
 if  ggt(heads,l) == 1 :
  for i in range(0,len(words)):  
    if differences( el(words[0+i],l),words[(len(words)-1+i) % len(words)] )==1:
  #    print("{} - {}".format(l,i))
      if hit==take :
         offset=i
         thel=l
      hit = hit + 1

print("offset={}".format(offset))    
print("L={}".format(thel))    

print("Done")     
#o=9/0
#offset = indexOf(words,"00000000001")
#for l in range(1,len(words)):
#  print("{} : {}".format(l,differences( el(words[0+offset],l),words[(len(words)-1+offset) % len(words)] )))
  

#offset = indexOf(words,"00000000001") # for 11

print("Offset: {}".format(offset))
print("L: {}".format(thel))
print("Orig. Start Word: {}".format(words[offset]))
print("Start Word: {}".format(words[offset]))
print("End Word:   {}".format(words[(len(words)-1+offset) % len(words)]))

#o=9/0
#l=0
bitstring=''

####
l=3
words2=[]
#for k in (range(0,1)):
for k in (range(0, 1 )): # heads
  for i in range(0,len(words)):
    word = words[ (i + offset) % len(words) ]
    words2.append( el(word,k*l) )   
words= words2
####

  
print("Number of words: {}".format(len(words)))   

print(words)



bitstring=''
for b in range(0, heads): # Warum?
   for word in words:   
     bitstring = bitstring + word[b]
print(len(bitstring))

#offset = indexOf(words,"00000000001")
#offset = indexOf(words,"00111")
#print( words[offset+1] )
#print( el(words[offset],l))
#print( differences(words[offset+1],el(words[offset],l)))



   
print("Heads={}".format(heads))
print("Len  ={}".format(len(bitstring)))
print(bitstring)

gap = int( len(bitstring) / heads)
print("Gap  ={}".format(gap))

#
rwords = {}
# Check single track property: subsequent codes read by heads my differ only in 1 bit:
violations=0
print(gap*heads)
print(len(bitstring))
#o=9/0

#for i in range(0,gap*heads):
for i in range(0,len(bitstring)):

   code = ''
   code2= ''
   for j in range(0,heads):
      #print(i+(j*heads % len(bitstring)))
      code = code +  bitstring[(offset+i+j*gap) % len(bitstring)] 
     
         
      code2 = code2 +  bitstring[(offset+i+1+j*gap) % len(bitstring)] 
   if code in rwords.keys():
      violations = violations + 1 
      print("duplicate word {}".format(code))
   else:
      rwords[code]=1
      
   if differences(code,code2)!=1 :
      violations = violations + 1
      print( "{}  / {} : {} - {} {} ".format(i,(offset+i+j*gap) % len(bitstring),differences(code,code2),code,code2))
      print(code)
print("Offset:     {}".format(offset))
print("Violations: {}".format(violations))


# calculate the histograms of lengths of equal bits for all heads
j=0
hists = []
old=0
n=0
for j in range(0,heads):
   hists.append({})
   for i in range(0,gap*heads):
     bit1 = bitstring[(offset+i+j*gap) % len(bitstring)] 
     if i==0:
       old=bit1
       n=1
     bit2 = bitstring[(offset+i+1+j*gap) % len(bitstring)]
     #print("{} {}".format(bit1,bit2))
     if bit1 == bit2:
       n=n+1
     else:
       old=bit2
     
       if n in hists[j].keys():
          hists[j][n]=hists[j][n]+1
       else:
          hists[j][n]=1
       #print("{}: {}".format(n,hist[n]))
       n=1
 
#for j in range(1,heads):
#    print("{} :  {}".format(j,hists[j]))
    
print(bitstring)
print(len(bitstring))
f=open("bitstring.dat", "w")
f.write(str(heads) + "\n")
f.write(bitstring)
f.close()

print("Violations: {}".format(violations))
